<template>
  <div class="container-fluid h-100 p-0">
    <LoadPayments
      v-show="showLoadPaymentsModal"
      @closeModal="toggleLoadPaymentModal"
    />
    <AssociatePayment
      v-show="showAssociatePaymentModal"
      :paymentId="paymentId"
      @closeModal="toggleAssociatePaymentModal(-1)"
    />
    <div class="container-fluid h-100" id="main">
      <div class="row">
        <div class="col-12 col-md-4 border-bottom text-start">
          <h1>Payments</h1>
        </div>
        <div class="col-12 col-md-8 text-start text-md-end mt-2">
          <SearchBar @search="setSearch" />
        </div>
      </div>
      <div class="row">
        <div class="col text-end">
          <button class="btn btn-warning" @click="filter = !filter">
            Filtrer
          </button>
          <button
            class="btn btn-secondary ms-2"
            @click="toggleLoadPaymentModal"
          >
            Charger payements
          </button>
        </div>
      </div>

      <div class="row border-top my-3" v-show="filter">
        <div class="col-12 col-md-2 text-start">
          <label class="fw-bold" for="selectCertificateStatus"
            >Status certificat:</label
          >
          <select
            class="form-select"
            id="selectCertificateStatus"
            aria-label="Default select example"
          >
            <option value="" disabled selected hidden></option>
            <option value="1">Valide</option>
            <option value="2">Rejeté</option>
            <option value="3">A valider</option>
            <option value="3">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start">
          <label for="selectVaStatus" class="fw-bold">Status VA:</label>
          <select
            class="form-select"
            id="selectVaStatus"
            aria-label="Default select example"
          >
            <option value="" disabled selected hidden></option>
            <option value="1">Valide</option>
            <option value="2">Rejeté</option>
            <option value="3">A valider</option>
            <option value="3">Pas nécéssaire</option>
            <option value="4">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start">
          <label for="" class="fw-bold">Status payement:</label>
          <select class="form-select" aria-label="Default select example">
            <option value="" disabled selected hidden></option>
            <option value="1">Valid</option>
            <option value="2">Partiel</option>
            <option value="3">A valider</option>
            <option value="3">Abscent</option>
          </select>
        </div>
        <div class="col-12 col-md-2 text-start d-flex align-middle">
          <button class="btn btn-secondary m-3">Reset</button>
        </div>
      </div>

      <div class="row rounded bg-light my-3">
        <table class="table table-striped table-hover">
          <thead>
            <tr>
              <th scope="col">Athlète</th>
              <th scope="col">Course</th>
              <th scope="col">Payé</th>
              <th scope="col">Date</th>
              <th scope="col">Associé</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="payment in payments" :key="payment.id">
              <td>{{ payment.last_name }} {{ payment.first_name }}</td>
              <td>{{ payment.category }}</td>
              <td>{{ payment.paid }}</td>
              <td>{{ payment.date }}</td>
              <td>
                <div v-if="payment.athlete">
                  <span
                    v-if="payment.athlete.status === 1"
                    class="badge rounded-pill bg-success"
                    @click="toggleAssociatePaymentModal(payment.id)"
                  >
                    Validé
                  </span>
                  <span
                    v-else-if="payment.athlete.status === 2"
                    class="badge rounded-pill bg-danger"
                    @click="toggleAssociatePaymentModal(payment.id)"
                  >
                    Rejeté
                  </span>
                  <span
                    v-else
                    class="badge rounded-pill bg-primary"
                    @click="toggleAssociatePaymentModal(payment.id)"
                  >
                    Associé
                  </span>
                </div>
                <span
                  v-else
                  class="badge rounded-pill bg-warning"
                  @click="toggleAssociatePaymentModal(payment.id)"
                >
                  A associé
                </span>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import SearchBar from "../components/searchBar/SearchBar.vue";
import LoadPayments from "../components/modals/paymentModal/loadPayments/LoadPayments.vue";
import AssociatePayment from "../components/modals/paymentModal/associatePayment/AssociatePayment.vue";
import axios from "axios";

export interface Athlete {
  id: number;
  status: number;
}

export interface Payment {
  id: number;
  command_reference: number;
  bank_reference: string;
  first_name: string;
  last_name: string;
  paid: number;
  email: string;
  category: string;
  date: string;
  athlete: Athlete | null;
}

export default defineComponent({
  components: {
    SearchBar,
    LoadPayments,
    AssociatePayment,
  },
  data() {
    return {
      search: null as unknown,
      filter: false,
      showLoadPaymentsModal: false,
      showAssociatePaymentModal: false,
      payments: [] as Payment[],
      paymentId: 0,
    };
  },
  methods: {
    setSearch(search: string) {
      this.search = search;
    },
    toggleLoadPaymentModal() {
      this.showLoadPaymentsModal = !this.showLoadPaymentsModal;
      this.reloadTable();
    },
    toggleAssociatePaymentModal(id: number) {
      console.log(id);
      if (id !== -1) {
        this.paymentId = id;
        console.log(this.paymentId);
      }
      this.showAssociatePaymentModal = !this.showAssociatePaymentModal;
      this.reloadTable();
    },
    reloadTable() {
      axios
        .get("payments")
        .then((response) => (this.payments = response.data["results"]));
    },
  },
  mounted() {
    this.reloadTable();
  },
});
</script>

<style></style>
